P=libusb
V=1.0.21
MAJOR=0
MINOR=0

# We don't use the upstream libusb-1.0/libusb name split: the 0.1 compat lib is
# small and needs to link with 1.0 anyway, so they can perfectly well coexist
# in one library file. With static linking, this costs the application nothing
# in code size or address space if it doesn't use the compat functions.

S="
$P-$V.tar.bz2
$P-compat-0.1.5.tar.bz2
Makefile
compat-config.h
config.h
libusb-0.1-ansi.patch
"

SHA512="
015ca07bdb559aa40af5db1302ab0b1c8a30d593699fe2f3c9f45162673dc7b608cecc58d60fde8f3bde2a68370794a045e8efa48fc55402eece11261e525762  libusb-1.0.21.tar.bz2
fe63bd1c65e67588a83ebfdd329025ecf75f33f877fb80dd83eb528df057efb591e010416027f9054294504562299166e8e2811a7681fa1967a03baae9b88857  libusb-compat-0.1.5.tar.bz2
"

build () {
	tar xjf $P-$V.tar.bz2
	tar xjf $P-compat-0.1.5.tar.bz2
	cd $P-compat-0.1.5
	patch -p1 <../libusb-0.1-ansi.patch
	mv libusb ../$P-$V/libusb/compat
	cd ../$P-$V
	cp ../config.h ../Makefile libusb
	cp ../compat-config.h libusb/compat/config.h
	cd libusb
	sed -i -e 's/<config\.h>/"config.h"/' compat/core.c
	make -j$JOBS CPPFLAGS='-I.' \
		CFLAGS='-fvisibility=hidden -O1 -Wall -Wextra -Wno-pointer-sign'
}

package () {
	r=gales/pkg/$Q
	cd $P-compat-0.1.5
	f $r/doc/ChangeLog.compat ChangeLog
	f $r/doc/README.compat README
	cd ../$P-$V
	f $r/doc/AUTHORS
	f $r/doc/ChangeLog
	f $r/doc/README
	cd libusb
	f $r/include/usb.h compat/usb.h
	f $r/include/libusb.h
	F $r/lib/libusb.a
	l gales/pkg/$P $Q
	l gales/doc/$P ../pkg/$P/doc
}
