P=ocaml
V=4.01.0
MAJOR=401
MINOR=0

# !!! BLOB ALERT !!!
# Bootstraps using precompiled bytecode in boot/ and generated code in
# camlp4/boot/. For slightly more confidence, you can use "make bootstrap" to
# verify the compiler recompiles itself with identical results (see INSTALL and
# the generated Makefile).

# !!! BLOAT ALERT !!!
# The resulting build is obnoxiously large (~160MB installed), far out of
# proportion to the source complexity, for reasons not yet fully identified.

S="
$P-$V.tar.xz http://caml.inria.fr/pub/distrib/$P-4.01/$P-$V.tar.xz
no-gprof.patch
byterun-cflags.patch
"

SHA512="
a1cc79b1f8910b9eed1ab62ff322cd6421d7e10a35b7720f53122603d704236b3b3314069e23058ade847897d1af8c8368845277e3273717efed00930cfa4447  ocaml-4.01.0.tar.xz
c1cdba3fa52ef03ca534b7a4932cfe29bbbc79b587d35ed7f6906eb09a5e5af97540def03b1e01c63dd2311dc4e5a6d02378d541d14688191e4f9302aff79c23  ocaml-4.06.0.tar.xz
"

build () {
	root=$PWD/root
	mkdir tmp
	export TMPDIR=$PWD/tmp
	tar xJf $P-$V.tar.xz
	cd $P-$V
	patch -p1 <../no-gprof.patch
	patch -p1 <../byterun-cflags.patch
	./configure -prefix /gales/pkg/$Q -libdir '$(PREFIX)/lib' \
		-no-shared-libs -no-curses -no-tk -no-graph
	make world.opt
	make install PREFIX=$root
	cd $root/bin
	# trim some of the pointless bloat (lib/camlp4 is the biggest though)
	rm -f ocamlbuild.native ocamlbuild.byte ocamldoc.opt
	# INSTALL indicates this should be safe (though it's out of date)
	strip camlp4 camlp4o* camlp4r* ocamlbuild ocamldoc *.opt
}

check () {
	echo 'Skipping broken testsuite'
	return
	# tests/lib-systhreads dies with "unknown C primitive `unix_waitpid'";
	# the test program works when executed directly but not via ocamlrun
	cd $P-$V/testsuite
	make all
}

package () {
	cd $P-$V
	f gales/pkg/$Q/doc/Changes
	f gales/pkg/$Q/doc/LICENSE
	f gales/pkg/$Q/doc/README
	cd ../root
	a gales/pkg/$Q/bin
	a gales/pkg/$Q/lib
	a gales/pkg/$Q/man
	l gales/pkg/$P $Q
	cd bin
	for f in *; do
		l gales/command/$f ../pkg/$P/bin/$f
	done
	l gales/doc/$P ../pkg/$P/doc
	l gales/man/$P ../pkg/$P/man
}
