#!/bin/sh
# Archived 2017-12-15 from http://cr.yp.to/ucspi-tcp.html
# Self-extracting archive generated by gales-util/ar.sh
dir=${1:-.}
printf 'Extracting to %s\n' "$dir"
cd -- "$dir" || exit
umask 022
if [ `id -u` -eq 0 ]; then
	attrs () { chown -- "$3" "$1"; chmod -- "$2" "$1"; }
else
	attrs () { chmod -- "$2" "$1"; }
fi
_rm () { rm -f -- "$@"; }
_mv () { mv -f -- "$@"; }
_ln_s () { ln -s -- "$@"; }
_mkdir_p () { mkdir -p -- "$@"; }
d () {
	printf %s/\\n "$1"
	_mkdir_p "$1" || return
	attrs "$@"
}
_f () {
	prog=$1; shift
	f=$1; shift
	d=`dirname -- "$f"`
	t="$f.__new"
	printf %s\\n "$f"
	_mkdir_p "$d" || return
	_rm "$t" || return
	$prog >"$t" || return
	attrs "$t" "$@"
	_mv "$t" "$f"
}
f () { _f "cut -b2-" "$@"; }
F () { _f "base64 -d" "$@"; }
l () {
	src=$1; dst=$2
	d=`dirname -- "$src"`
	printf '%s -> %s\n' "$src" "$dst"
	if [ -d "$src" ]; then
		_mkdir_p "$d/__new" || return
		f=`basename -- "$src"`
		t="$d/__new/$f"
		_rm "$t" || return
		_ln_s "$dst" "$t" || return
		_mv "$t" "$d" || _rm "$t"
		rmdir -- "$d/__new"
	else
		_mkdir_p "$d" || return
		t="$src.__new"
		_rm "$t" || return
		_ln_s "$dst" "$t" || return
		_mv "$t" "$src"
	fi
}
i () { printf '>> INFO: %s\n' "$1"; }
#end-preamble
d 'doc' 755 0:0
d 'doc/proto' 755 0:0
f 'doc/proto/ucspi-tcp.txt' 644 0:0 <<'.'
	TCP UCSPI protocol definition
	Copyright 1996
	D. J. Bernstein, djb@pobox.com
	
	
	This document defines the TCP protocol for UCSPI-1996 tools. A TCP
	client communicates with a TCP server, on the same machine or on a
	different machine, via the TCP/IP protocol through an Internet-domain
	socket. The descriptors passed to a TCP UCSPI application are copies of
	that socket, dup()ed from a single connect() or accept().
	
	[address] consists of two arguments: [hostname] [port].
	
	There are three possibilities for [hostname]: the number 0, referring to
	the local host; a dotted-decimal IP address, such as 192.48.96.5; or a
	name understood by the system's resolver, such as mail.uu.net. TCP UCSPI
	servers use only the first IP address from the resolver; TCP UCSPI
	clients try each address in turn.
	
	There are three possibilities for [port]: a positive numeric TCP port
	number, such as 25; the number 0, which permits selection of any port
	number; or a name understood by the system's getservbyname(), such as
	smtp.
	
	The client and server set up the following environment variables:
	
	   PROTO: the string TCP
	   TCPLOCALIP: the dotted-decimal IP address of the local host
	   TCPLOCALPORT: the local TCP port number, in decimal
	   TCPREMOTEIP: the dotted-decimal IP address of the remote host
	   TCPREMOTEPORT: the remote TCP port number, in decimal
	   TCPLOCALHOST, if possible: the resolver's name for TCPLOCALIP
	   TCPREMOTEHOST, if possible: the resolver's name for TCPREMOTEIP
	   TCPREMOTEINFO, if possible: the result of a 931/1413/IDENT/TAP query
	
	Uppercase letters in TCPLOCALHOST and TCPREMOTEHOST are converted to
	lowercase. TCPREMOTEINFO is a connection-specific string supplied by the
	remote host via 931/1413/IDENT/TAP.
	
	TCP UCSPI tools take a -R option to turn off 931/1413/IDENT/TAP
	querying, and a -r option to turn it back on. TCP UCSPI clients take a
	-p [locport] option to require a particular TCP port on the local side
	of the connection. TCP UCSPI servers take a -1 option to print the local
	port number (in decimal, followed by a newline) to descriptor 1 before
	closing descriptor 1 and after preparing to receive connections.
.
f 'doc/proto/ucspi.txt' 644 0:0 <<'.'
	UNIX Client-Server Program Interface, UCSPI-1996
	Copyright 1996
	D. J. Bernstein, djb@pobox.com
	
	
	1. Introduction
	
	This document describes the UNIX Client-Server Program Interface, UCSPI
	(ooks-pie), a command-line interface to client-server communications
	tools.
	
	UCSPI provides several benefits. First, the UCSPI interface is
	independent of the underlying communications medium; UCSPI applications
	don't even have to be recompiled as the Internet upgrades from IPv4 to
	IPv6. Second, UCSPI lets shell scripts take advantage of networking.
	Third, UCSPI clients and servers conventionally set up environment
	variables that display the local and remote addresses, so the
	information is readily available to applications and users.
	
	Here is the general UCSPI framework. An UCSPI tool is a program that
	understands how to talk to some communications medium. It sets up two
	descriptors and then invokes an UCSPI application, which can read from
	one descriptor and write to the other. Every communications medium
	provides reliable two-way full-duplex strictly ordered not necessarily
	timed stream communication. Some media may provide other types of
	communication, such as expedited (``out-of-band'') transmission, in
	which the stream is no longer ordered, but most UCSPI applications are
	medium-independent and do not rely on such features.
	
	
	2. Tools
	
	UCSPI tools are executable programs. They accept command lines in the
	following general format:
	
	   [tool] [options] [address] [application]
	
	Here [tool] is the name of the tool, [options] are zero or more option
	arguments, [address] is a protocol-specific address, and [application]
	is a user-specified program to run for each connection.
	
	[options] are processed by the getopt standard; thus an argument of --
	terminates [options]. [tool] supports three options to control how
	much information it prints to stderr:
	
	   -v all available messages
	   -Q all available error messages; no messages in case of success
	   -q no messages in any case
	
	The default is -Q; later arguments override earlier arguments. [tool]
	may support many further options.
	
	[application] consists of one or more arguments, handled by the
	conventions of execvp(). [tool] passes on all [application] arguments
	without change, no matter what characters appear in those arguments.
	
	[tool] always changes certain file descriptors, as described in section
	3, and environment variables, as described in section 4, before
	executing [application].
	
	[tool] might fork before executing [application], and it might reset
	some signals that were previously ignored. Other than this, [tool] does
	not change its process state before executing [application].
	
	[tool] does not assume that any particular descriptors are open or
	closed upon entry. [tool] does not force itself into the background; nor
	does it attempt to detach from a controlling terminal.
	
	If [tool] cannot perform its functions, it exits with a nonzero code.
	
	
	3. Clients and servers
	
	There are two types of UCSPI tools: clients and servers.
	
	An UCSPI client closes descriptors 6 and 7 and connects to a server at
	[address]. Upon connecting, it spawns [application] with descriptor 6
	reading from the connection and descriptor 7 writing to the connection.
	The client does not make any further connections. When [application]
	dies, the client dies; the client exits with a zero code if and only if
	[application] exited with a zero code.
	
	An UCSPI server closes descriptors 0 and 1 and waits for a client to
	connect to [address]. Upon accepting a connection, it spawns
	[application] with descriptor 0 reading from the connection and
	descriptor 1 writing to the connection. Meanwhile, and subsequently, it
	continues accepting connections to [address]. If the server receives
	signal SIGTERM, it exits with code 0; this does not affect any current
	connections.
	
	
	4. Protocols
	
	Each UCSPI tool supports a protocol. A protocol definition provides
	three pieces of information: the name of the protocol; the format and
	meaning of [address]; and the environment variables set up by the tool.
	
	A protocol name is a sequence of one or more alphanumeric characters.
	See section 5 for information about the allocation of protocol names.
	
	A protocol definition always states the number of arguments taken by
	[address] and the allowed form for each argument. It also states an
	underlying communications medium to be used by the tool, and gives the
	interpretation of [address] in terms of that medium.
	
	Each tool passes the following environment variables to [application]:
	PROTO=[PROTO], the name of the supported protocol; zero or more
	variables beginning with [PROTO]LOCAL, as stated in the protocol
	definition; and zero or more variables beginning with [PROTO]REMOTE, as
	stated in the protocol definition. For clients, [PROTO]LOCAL variables
	give information about the client, and [PROTO]REMOTE variables give
	information about the server; vice versa for servers.
	
	Protocol definitions may specify environment variables that, in some
	situations, are not set. Those variables might be set upon entry to an
	UCSPI tool; if so, they must be unset, not passed along.
	
	A protocol definition may impose further requirements on clients and
	servers, such as supported options, forking behavior, and the nature of
	the descriptors passed to [application].
	
	
	5. Protocol management
	
	Public protocol definitions may be registered with me. I may refuse a
	registration request on the grounds of a namespace problem, but in that
	case I will suggest an acceptable replacement name.
	
	Protocol names beginning with x will be parcelled out to organizations
	that would like to define their own protocols. Protocol names beginning
	with X are reserved for experimental use.
.
d 'doc/ucspi-tcp' 755 0:0
f 'doc/ucspi-tcp/addcr.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>addcr</tt> and <tt>delcr</tt> programs</h1>
	<tt>addcr</tt> inserts a CR (\015) before each LF (\012),
	i.e., at the end of each line of input.
	It does not insert a CR at the end of a partial final line.
	<p>
	<tt>delcr</tt> removes a CR at the end of each line of input,
	if a CR is present.
	It does not remove a CR at the end of a partial final line.
	<p>
	Some <tt>unix2dos</tt> and <tt>dos2unix</tt> programs
	have trouble with long lines and nulls.
	<tt>addcr</tt> and <tt>delcr</tt>
	have no trouble with long lines and nulls.
	</body>
	</html>
.
f 'doc/ucspi-tcp/argv0.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>argv0</tt> program</h1>
	<tt>argv0</tt> runs a program with a specified 0th argument.
	<h2>Interface</h2>
	<pre>
	     argv0 <i>realname</i> <i>zero</i> <i>args</i>
	</pre>
	<tt><i>realname</i></tt> is one argument.
	<tt><i>zero</i></tt> is one argument.
	<tt><i>args</i></tt> is any number of arguments.
	<p>
	<tt>argv0</tt> runs the program stored as <tt><i>realname</i></tt> on disk,
	with <tt><i>zero</i></tt> as the 0th argument
	(rather than <tt><i>realname</i></tt>)
	and <tt><i>args</i></tt> as the remaining arguments.
	<h2>Applications</h2>
	Some programs pay special attention to the 0th argument.
	<tt>argv0</tt> makes these programs usable from shell scripts.
	<p>
	For example,
	<pre>
	     argv0 /bin/csh -csh
	</pre>
	runs <tt>/bin/csh</tt> with a 0th argument of <tt>-csh</tt>.
	<tt>/bin/csh</tt> will think it is a login shell and behave accordingly.
	<p>
	As another example, the command
	<pre>
	     tcpserver 0 ftp argv0 tcpd ftpd -l -A
	</pre>
	has a similar effect to the line
	<pre>
	     ftp stream tcp nowait root tcpd ftpd -l -A
	</pre>
	in <tt>/etc/inetd.conf</tt>.
	The <tt>tcpd</tt> program is run with 0th argument <tt>ftpd</tt>
	and remaining arguments <tt>-l -A</tt>.
	Note that <tt>tcpd</tt> can and should be replaced by the <tt>-x</tt> option of
	<a href="tcpserver.html"><tt>tcpserver</tt></a>:
	<pre>
	     tcpserver -x ftp.tcp 0 ftp ftpd -l -A
	</pre>
	</body>
	</html>
.
f 'doc/ucspi-tcp/date@.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>date@</tt> program</h1>
	<tt>date@</tt> prints the date on a remote host.
	<h2>Interface</h2>
	<pre>
	     date@ <i>host</i>
	</pre>
	<tt>date@</tt> connects to TCP port 13 (Daytime)
	on <tt><i>host</i></tt>
	and prints any data it receives.
	It removes CR (\015) and converts unprintable characters
	to a visible format.
	<p>
	If <tt><i>host</i></tt> is not supplied,
	<tt>date@</tt> connects to the local host.
	<p>
	Some computers respond to port 13
	with a human-readable date.
	For example, they may be running
	<pre>
	     tcpserver -RHl0 0 13 date
	</pre>
	using <a href="tcpserver.html"><tt>tcpserver</tt></a>.
	</body>
	</html>
.
f 'doc/ucspi-tcp/environment.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>TCP environment variables</h1>
	<tt>$PROTO</tt> is the string <tt>TCP</tt>.
	<p>
	<tt>$TCPLOCALIP</tt> is the IP address of the local host,
	in dotted-decimal form.
	<p>
	<tt>$TCPLOCALPORT</tt> is the local TCP port number, in decimal.
	<p>
	<tt>$TCPLOCALHOST</tt> is the name listed in DNS for the local host.
	If no name is available, <tt>$TCPLOCALHOST</tt> is not set.
	Beware that <tt>$TCPLOCALHOST</tt> can contain arbitrary characters.
	<p>
	<tt>$TCPREMOTEIP</tt> is the IP address of the remote host,
	in dotted-decimal form.
	<p>
	<tt>$TCPREMOTEPORT</tt> is the remote TCP port number, in decimal.
	<p>
	<tt>$TCPREMOTEHOST</tt> is the name listed in DNS for the remote host.
	If no name is available, <tt>$TCPREMOTEHOST</tt> is not set.
	Beware that <tt>$TCPREMOTEHOST</tt> can contain arbitrary characters.
	<p>
	<tt>$TCPREMOTEINFO</tt> is a connection-specific string
	supplied by the remote host via the 931/1413/IDENT/TAP protocol.
	If no information is available, <tt>$TCPREMOTEINFO</tt> is not set.
	Beware that <tt>$TCPREMOTEINFO</tt> can contain arbitrary characters.
	</body>
	</html>
.
f 'doc/ucspi-tcp/finger@.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>finger@</tt> program</h1>
	<tt>finger@</tt> gets user information from a remote host.
	<h2>Interface</h2>
	<pre>
	     finger@ <i>host</i> <i>user</i>
	</pre>
	<tt>finger@</tt> connects to TCP port 79 (Finger)
	on <tt><i>host</i></tt>,
	sends <tt><i>user</i></tt> (with an extra CR)
	to <tt><i>host</i></tt>,
	and prints any data it receives.
	It removes CR and converts unprintable characters
	to a visible format.
	<p>
	Some computers respond to port 79
	with information about <tt><i>user</i></tt>.
	<p>
	If <tt><i>user</i></tt> is not supplied,
	<tt>finger@</tt> sends a blank line to <tt><i>host</i></tt>.
	Some computers respond with information about all the users who are logged in.
	<p>
	If <tt><i>host</i></tt> is not supplied,
	<tt>finger@</tt> connects to the local host.
	</body>
	</html>
.
f 'doc/ucspi-tcp/fixcrio.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>fixcrio</tt> program</h1>
	<tt>fixcrio</tt> inserts missing CRs at the ends of lines.
	<h2>Interface</h2>
	<pre>
	     fixcrio <i>prog</i>
	</pre>
	<tt>fixcrio</tt> runs <tt><i>prog</i></tt>.
	It inserts CR
	at the end of each line of input or output to <tt><i>prog</i></tt>
	that does not have a CR.
	<p>
	<tt>fixcrio</tt> runs as a child process of <tt><i>prog</i></tt>.
	It exits when it sees the end of <tt><i>prog</i></tt>'s output.
	</body>
	</html>
.
f 'doc/ucspi-tcp/http@.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>http@</tt> program</h1>
	<tt>http@</tt> gets a web page from a remote host.
	<h2>Interface</h2>
	<pre>
	     http@ <i>host</i> <i>page</i> <i>port</i>
	</pre>
	<tt>http@</tt> connects to <tt><i>port</i></tt> on <tt><i>host</i></tt>,
	sends
	<pre>
	     GET /<i>page</i> HTTP/1.0
	     Host: <tt><i>host</i></tt>
	
	</pre>
	to <tt><i>host</i></tt>,
	and prints the contents of the response,
	removing CR from the end of each line.
	<p>
	If <tt><i>port</i></tt> is not supplied,
	<tt>http@</tt> uses TCP port 80 (HTTP).
	<p>
	If <tt><i>page</i></tt> is not supplied,
	<tt>http@</tt> asks for <tt>/</tt> from <tt><i>host</i></tt>.
	<p>
	If <tt><i>host</i></tt> is not supplied,
	<tt>http@</tt> connects to the local host.
	</body>
	</html>
.
f 'doc/ucspi-tcp/install.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>How to install ucspi-tcp</h1>
	Like any other piece of software (and information generally),
	ucspi-tcp comes with NO WARRANTY.
	<h2>System requirements</h2>
	ucspi-tcp works only under UNIX.
	<h2>Installation</h2>
	Download the ucspi-tcp package.
	The latest published ucspi-tcp package is
	<a href="ucspi-tcp-0.88.tar.gz">ucspi-tcp-0.88.tar.gz</a>.
	<p>
	Unpack the ucspi-tcp package:
	<pre>
	     gunzip ucspi-tcp-0.88.tar
	     tar -xf ucspi-tcp-0.88.tar
	     cd ucspi-tcp-0.88
	</pre>
	<p>
	Compile the ucspi-tcp programs:
	<pre>
	     make
	</pre>
	<p>
	As root, install the ucspi-tcp programs
	under <tt>/usr/local</tt>:
	<pre>
	     make setup check
	</pre>
	<p>
	To report success:
	<pre>
	     ( echo 'First M. Last'; cat `cat SYSDEPS` ) \
	     | mail djb-sysdeps@cr.yp.to
	</pre>
	Replace <tt>First M. Last</tt> with your name.
	</body>
	</html>
.
f 'doc/ucspi-tcp/mconnect.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>mconnect</tt> program</h1>
	<tt>mconnect</tt> connects to a remote SMTP server.
	<h2>Interface</h2>
	<pre>
	     mconnect <i>host</i> <i>port</i>
	</pre>
	<tt>mconnect</tt>
	connects to <tt><i>port</i></tt> on <tt><i>host</i></tt>.
	It sends its input to <tt><i>host</i></tt>,
	adding a CR to each line.
	Meanwhile it prints anything it receives from <tt><i>host</i></tt>.
	<p>
	If <tt>port</tt> is not supplied,
	<tt>mconnect</tt> uses port 25 (SMTP).
	<p>
	If <tt>host</tt> is not supplied,
	<tt>mconnect</tt> connects to the local host.
	</body>
	</html>
.
f 'doc/ucspi-tcp/rblsmtpd.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>rblsmtpd</tt> program</h1>
	<tt>rblsmtpd</tt> blocks mail from RBL-listed sites.
	It works with any SMTP server that can run under
	<a href="tcpserver.html"><tt>tcpserver</tt></a>.
	<h2>Interface</h2>
	<pre>
	     rblsmtpd <i>opts</i> <i>prog</i>
	</pre>
	<tt><i>opts</i></tt>
	is a series of <tt>getopt</tt>-style options.
	<tt><i>prog</i></tt>
	consists of one or more arguments.
	<p>
	Normally <tt>rblsmtpd</tt> runs <tt><i>prog</i></tt>.
	<tt><i>prog</i></tt> is expected to carry out an SMTP conversation
	to receive incoming mail messages.
	<p>
	However, <tt>rblsmtpd</tt> does not invoke <tt><i>prog</i></tt>
	if it is told to block mail from this client.
	Instead it carries out its own limited SMTP conversation,
	temporarily rejecting all attempts to send a message.
	Meanwhile it prints one line on descriptor 2 to log its activity.
	<p>
	<tt>rblsmtpd</tt> drops the limited SMTP conversation
	after 60 seconds,
	even if the client has not quit by then.
	<p>
	Options:
	<ul>
	<li><tt>-t <i>n</i></tt>:
	Change the 60-second timeout to <tt><i>n</i></tt> seconds.
	</ul>
	<h2>Blocked clients</h2>
	If the <tt>$RBLSMTPD</tt> environment variable is set and is nonempty,
	<tt>rblsmtpd</tt> blocks mail.
	It uses <tt>$RBLSMTPD</tt> as an error message for the client.
	Normally <tt>rblsmtpd</tt> runs under
	<a href="tcpserver.html"><tt>tcpserver</tt></a>;
	you can use
	<a href="tcprules.html"><tt>tcprules</tt></a>
	to set <tt>$RBLSMTPD</tt> for selected clients.
	<p>
	If <tt>$RBLSMTPD</tt> is set and is empty,
	<tt>rblsmtpd</tt> does not block mail.
	<p>
	If <tt>$RBLSMTPD</tt> is not set,
	<tt>rblsmtpd</tt> looks up <tt>$TCPREMOTEIP</tt> in the RBL,
	and blocks mail if <tt>$TCPREMOTEIP</tt> is listed.
	<tt>tcpserver</tt> sets up <tt>$TCPREMOTEIP</tt>
	as the IP address of the remote host.
	<p>
	Options:
	<ul>
	<li><tt>-r <i>base</i></tt>:
	Use <tt><i>base</i></tt> as an RBL source.
	An IP address <tt><i>a</i>.<i>b</i>.<i>c</i>.<i>d</i></tt>
	is listed by that source if
	<tt><i>d</i>.<i>c</i>.<i>b</i>.<i>a</i>.<i>base</i></tt>
	has a TXT record.
	<tt>rblsmtpd</tt> uses the contents of the TXT record
	as an error message for the client.
	<li><tt>-a <i>base</i></tt>:
	Use <tt><i>base</i></tt> as an anti-RBL source.
	An IP address <tt><i>a</i>.<i>b</i>.<i>c</i>.<i>d</i></tt>
	is anti-listed by that source if
	<tt><i>d</i>.<i>c</i>.<i>b</i>.<i>a</i>.<i>base</i></tt>
	has an A record.
	In this case <tt>rblsmtpd</tt> does not block mail.
	</ul>
	<p>
	You may supply any number of <tt>-r</tt> and <tt>-a</tt> options.
	<tt>rblsmtpd</tt> tries each source in turn
	until it finds one that lists or anti-lists <tt>$TCPREMOTEIP</tt>.
	<p>
	If you do not supply any <tt>-r</tt> options,
	<tt>rblsmtpd</tt> tries an RBL source of <tt>rbl.maps.vix.com</tt>.
	This will be changed in subsequent versions.
	<h2>RBL sources</h2>
	If you want to run your own RBL source or anti-RBL source for <tt>rblsmtpd</tt>,
	you can use
	<a href="../djbdns/rbldns.html"><tt>rbldns</tt></a>
	from the djbdns package.
	<p>
	I've heard about the following public RBL sources:
	<ul>
	<li><tt>dev.null.dk</tt>
	<li><tt>list.dsbl.org</tt>, using <tt>rbldns</tt> as of 2002-03
	<li><tt>multihop.dsbl.org</tt>, using <tt>rbldns</tt> as of 2002-03
	<li><tt>orbs.dorkslayers.com</tt>
	<li><tt>orbz.gst-group.co.uk</tt>
	<li><tt>relays.osirusoft.com</tt>
	<li><tt>unconfirmed.dsbl.org</tt>, using <tt>rbldns</tt> as of 2002-03
	<li><tt>dnsbl.sorbs.net</tt>
	<li><tt>cbl.abuseat.org</tt>
	</ul>
	I've given up on the following RBL sources for various reasons:
	<ul>
	<li><tt>blackholes.mail-abuse.org</tt>,
	demanding money for access as of 2001-07
	<li><tt>dialups.mail-abuse.org</tt>,
	demanding money for access as of 2001-07
	<li><tt>dul.maps.vix.com</tt>, renamed <tt>dialups.mail-abuse.org</tt>
	<li><tt>inputs.orbz.org</tt>, disabled as of 2002-03
	<li><tt>outputs.orbs.org</tt>, disabled in 2001-06
	<li><tt>outputs.orbz.org</tt>, disabled as of 2002-03
	<li><tt>rbl.maps.vix.com</tt>, renamed <tt>blackholes.mail-abuse.org</tt>
	<li><tt>relays.mail-abuse.org</tt>,
	TXT records eliminated in 2000-08,
	demanding money for access as of 2001-07
	<li><tt>relays.msci.memphis.edu</tt>,
	a copy of <tt>relays.mail-abuse.org</tt> with TXT records,
	disabled in 2001-01 because <tt>mail-abuse.org</tt> started demanding money
	<li><tt>rss.maps.vix.com</tt>, renamed <tt>relays.mail-abuse.org</tt>
	<li><tt>or.orbl.org</tt>, down as of 2001-10
	<li><tt>relays.ordb.org</tt>,
	no longer in operation
	<li><tt>bl.spamcop.net</tt>,
	fails to interoperate with deferred-delivery ISPs
	</ul>
	<tt>relays.mail-abuse.org</tt>
	stopped working with <tt>rblsmtpd</tt> in August 2000,
	because all the TXT records were removed.
	``They were eliminated because the zone file is growing rather large,''
	the maintainers said.
	This problem wouldn't occur with <tt>rbldns</tt>,
	because <tt>rbldns</tt> databases are much smaller than zone files.
	However, the people who run MAPS also have financial interests in BIND,
	and they refuse to use <tt>rbldns</tt>.
	<h2>Temporary errors</h2>
	Normally,
	if <tt>$RBLSMTPD</tt> is set,
	<tt>rblsmtpd</tt> uses a 451 error code
	in its limited SMTP conversation.
	This tells legitimate clients to try again later.
	It gives innocent relay operators
	a chance to see the problem,
	prohibit relaying,
	get off the RBL,
	and get the mail delivered.
	<p>
	However, if <tt>$RBLSMTPD</tt> begins with a hyphen,
	<tt>rblsmtpd</tt> removes the hyphen
	and uses a 553 error code.
	This tells legitimate clients to bounce the message immediately.
	<p>
	There are several error-handling options for RBL lookups:
	<ul>
	<li><tt>-B</tt>:
	(Default.)
	Use a 451 error code for IP addresses listed in the RBL.
	<li><tt>-b</tt>:
	Use a 553 error code for IP addresses listed in the RBL.
	<li><tt>-C</tt>:
	(Default.)
	Handle RBL lookups in a ``fail-open'' mode.
	If an RBL lookup fails temporarily,
	assume that the address is not listed;
	if an anti-RBL lookup fails temporarily,
	assume that the address is anti-listed.
	Unfortunately, a knowledgeable attacker
	can force an RBL lookup or an anti-RBL lookup to fail temporarily,
	so that his mail is not blocked.
	<li><tt>-c</tt>:
	Handle RBL lookups in a ``fail-closed'' mode.
	If an RBL lookup fails temporarily,
	assume that the address is listed
	(but use a 451 error code even with <tt>-b</tt>).
	If an anti-RBL lookup fails temporarily,
	assume that the address is not anti-listed
	(but use a 451 error code
	even if a subsequent RBL lookup succeeds with <tt>-b</tt>).
	Unfortunately, this sometimes delays legitimate mail.
	</ul>
	<h2>Acknowledgments</h2>
	Thanks to Andrew Richards for his comments on this documentation.
	</body>
	</html>
.
f 'doc/ucspi-tcp/recordio.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>recordio</tt> program</h1>
	<tt>recordio</tt> records the input and output of a program.
	<h2>Interface</h2>
	<pre>
	     recordio <i>prog</i>
	</pre>
	<tt>recordio</tt> runs <tt><i>prog</i></tt>.
	It prints lines to descriptor 2
	showing the input and output of <tt><i>prog</i></tt>.
	<p>
	At the beginning of each line on descriptor 2,
	<tt>recordio</tt> inserts the <tt><i>prog</i></tt> process ID,
	along with <tt>&lt;</tt> for input or <tt>&gt;</tt> for output.
	At the end of each line it inserts <tt>+</tt>, a space, or <tt>[EOF]</tt>;
	a space indicates that there was a new line in the input or output,
	and <tt>[EOF]</tt> indicates the end of input or output.
	<p>
	<tt>recordio</tt> prints every packet of input and output immediately.
	It does not attempt to combine packets into coherent lines.
	For example,
	<pre>
	     recordio sh -c 'cat /dev/fd/8 2&gt;&amp;1' &gt; /dev/null
	</pre>
	could produce
	<pre>
	     5135 &gt; cat: /dev/fd/8: Bad file descriptor 
	     5135 &gt; [EOF]
	</pre>
	or
	<pre>
	     5135 &gt; cat: +
	     5135 &gt; /dev/fd/8+
	     5135 &gt; : +
	     5135 &gt; Bad file descriptor 
	     5135 &gt; [EOF]
	</pre>
	if the <tt>cat</tt> program prints several packets.
	<p>
	<tt>recordio</tt> uses several lines for long packets
	to guarantee that each line is printed atomically.
	<p>
	<tt>recordio</tt> runs as a child process of <tt><i>prog</i></tt>.
	It exits when it sees the end of <tt><i>prog</i></tt>'s output.
	</body>
	</html>
.
f 'doc/ucspi-tcp/tcpcat.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>tcpcat</tt> program</h1>
	<tt>tcpcat</tt> prints data from a remote host.
	<h2>Interface</h2>
	<pre>
	     tcpcat <i>host</i> <i>port</i>
	</pre>
	<tt>tcpcat</tt>
	connects to <tt><i>port</i></tt> on <tt><i>host</i></tt>.
	It prints any data it receives.
	<p>
	<tt>tcpcat</tt>
	can be used to transfer binary data.
	It does no conversions.
	</body>
	</html>
.
f 'doc/ucspi-tcp/tcpclient.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>tcpclient</tt> program</h1>
	<tt>tcpclient</tt> creates an outgoing TCP connection.
	<h2>Interface</h2>
	<pre>
	     tcpclient <i>opts</i> <i>host</i> <i>port</i> <i>prog</i>
	</pre>
	<tt><i>opts</i></tt>
	is a series of <tt>getopt</tt>-style options.
	<tt><i>host</i></tt> is one argument.
	<tt><i>port</i></tt> is one argument.
	<tt><i>prog</i></tt> consists of one or more arguments.
	<p>
	<tt>tcpclient</tt> attempts to connect to a TCP server.
	If it is successful,
	it runs <tt><i>prog</i></tt>,
	with descriptor 6 reading from the network
	and descriptor 7 writing to the network.
	It also sets up several
	<a href="environment.html">environment variables</a>.
	<p>
	The server's address is given by <tt><i>host</i></tt> and <tt><i>port</i></tt>.
	<tt><i>port</i></tt> may be a name from <tt>/etc/services</tt> or a number.
	<tt><i>host</i></tt> may be <tt>0</tt>,
	referring to the local machine,
	or a dotted-decimal IP address,
	or a host name;
	it is fed through
	<a href="../djbdns/qualify.html">qualification</a>
	using <tt>dns_ip4_qualify</tt>.
	<p>
	If the server has several IP addresses,
	<tt>tcpclient</tt> tries each address in turn.
	<h2>Options</h2>
	General options:
	<ul>
	<li><tt>-q</tt>: Quiet. Do not print error messages.
	<li><tt>-Q</tt>: (Default.) Print error messages.
	<li><tt>-v</tt>: Verbose. Print error messages and status messages.
	</ul>
	Connection options:
	<ul>
	<li><tt>-T <i>x</i>+<i>y</i></tt>:
	Give up on the connection attempt after <tt><i>x</i>+<i>y</i></tt> seconds.
	Default: <tt>2+58</tt>.
	When a host has several IP addresses,
	<tt>tcpclient</tt> tries to connect to the first IP address,
	waits <tt><i>x</i></tt> seconds,
	tries to connect to the second IP address,
	waits <tt><i>x</i></tt> seconds, etc.;
	then it retries each address that timed out,
	waiting <tt><i>y</i></tt> seconds per address.
	You may omit <tt>+<i>y</i></tt> to skip the second try.
	Before version 0.88, <tt>tcpclient</tt> will use only <tt><i>x</i></tt>
	(default: <tt>60</tt>).
	<li><tt>-i <i>localip</i></tt>: Use <tt><i>localip</i></tt>
	as the IP address for the local side of the connection;
	quit if <tt><i>localip</i></tt> is not available.
	Normally <tt>tcpclient</tt> lets the operating system choose an address.
	<li><tt>-p <i>localport</i></tt>: Use <tt><i>localport</i></tt>
	as the TCP port for the local side of the connection;
	quit if <tt><i>localport</i></tt> is not available.
	Normally <tt>tcpclient</tt> lets the operating system choose a port.
	<li><tt>-d</tt>: Delay sending data for a fraction of a second
	whenever the remote host is responding slowly.
	This is currently the default, but it may not be in the future;
	if you want it, set it explicitly.
	<li><tt>-D</tt>: Never delay sending data; enable <tt>TCP_NODELAY</tt>.
	</ul>
	Data-gathering options:
	<ul>
	<li><tt>-h</tt>: (Default.)
	Look up the remote host name in DNS
	to set the environment variable <tt>$TCPREMOTEHOST</tt>.
	<li><tt>-H</tt>:
	Do not look up the remote host name in DNS;
	remove the environment variable <tt>$TCPREMOTEHOST</tt>.
	<li><tt>-l <i>localname</i></tt>:
	Do not look up the local host name in DNS;
	use <tt><i>localname</i></tt> for the environment variable <tt>$TCPLOCALHOST</tt>.
	A common choice for <tt><i>localname</i></tt> is <tt>0</tt>.
	<li><tt>-r</tt>: (Default.)
	Attempt to obtain <tt>$TCPREMOTEINFO</tt> from the remote host.
	<li><tt>-R</tt>:
	Do not attempt to obtain <tt>$TCPREMOTEINFO</tt> from the remote host.
	<li><tt>-t <i>n</i></tt>:
	Give up on the <tt>$TCPREMOTEINFO</tt> connection attempt
	after <tt><i>n</i></tt> seconds.
	Default: 26.
	</ul>
	</body>
	</html>
.
f 'doc/ucspi-tcp/tcprulescheck.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>tcprulescheck</tt> program</h1>
	<pre>
	     tcprulescheck <i>cdb</i>
	</pre>
	<tt>tcprulescheck</tt>
	says what
	<a href="tcpserver.html"><tt>tcpserver</tt></a>
	will do with a connection
	from IP address <tt>$TCPREMOTEIP</tt>
	with host name <tt>$TCPREMOTEHOST</tt>
	and remote connection information <tt>$TCPREMOTEINFO</tt>,
	following the rules compiled into
	<tt><i>cdb</i></tt> by
	<a href="tcprules.html"><tt>tcprules</tt></a>.
	</body>
	</html>
.
f 'doc/ucspi-tcp/tcpserver.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>tcpserver</tt> program</h1>
	<tt>tcpserver</tt> accepts incoming TCP connections.
	<h2>Interface</h2>
	<pre>
	     tcpserver <i>opts</i> <i>host</i> <i>port</i> <i>prog</i>
	</pre>
	<tt><i>opts</i></tt>
	is a series of <tt>getopt</tt>-style options.
	<tt><i>host</i></tt> is one argument.
	<tt><i>port</i></tt> is one argument.
	<tt><i>prog</i></tt> consists of one or more arguments.
	<p>
	<tt>tcpserver</tt> waits for connections from TCP clients.
	For each connection, it runs <tt><i>prog</i></tt>,
	with descriptor 0 reading from the network
	and descriptor 1 writing to the network.
	It also sets up several
	<a href="environment.html">environment variables</a>.
	<p>
	The server's address is given by <tt><i>host</i></tt> and <tt><i>port</i></tt>.
	<tt><i>port</i></tt> may be a name from <tt>/etc/services</tt> or a number;
	if it is <tt>0</tt>,
	<tt>tcpserver</tt> will choose a free TCP port.
	<tt><i>host</i></tt> may be <tt>0</tt>,
	allowing connections to any local IP address;
	or a dotted-decimal IP address,
	allowing connections only to that address;
	or a host name,
	allowing connections to the <i>first</i> IP address for that host.
	Host names are fed through
	<a href="../djbdns/qualify.html">qualification</a>
	using <tt>dns_ip4_qualify</tt>.
	<p>
	<tt>tcpserver</tt> exits when it receives SIGTERM.
	<h2>Options</h2>
	General options:
	<ul>
	<li><tt>-q</tt>: Quiet. Do not print error messages.
	<li><tt>-Q</tt>: (Default.) Print error messages.
	<li><tt>-v</tt>: Verbose. Print error messages and status messages.
	</ul>
	Connection options:
	<ul>
	<li><tt>-c <i>n</i></tt>:
	Do not handle more than <tt><i>n</i></tt> simultaneous connections.
	If there are <tt><i>n</i></tt> simultaneous copies of <tt><i>prog</i></tt>
	running,
	defer acceptance of a new connection until one copy finishes.
	<tt><i>n</i></tt> must be a positive integer.
	Default: 40.
	<li><tt>-x <i>cdb</i></tt>:
	Follow the rules compiled into <tt><i>cdb</i></tt> by 
	<a href="tcprules.html"><tt>tcprules</tt></a>.
	These rules may specify setting environment variables
	or rejecting connections from bad sources.
	You can rerun <tt>tcprules</tt>
	to change the rules while <tt>tcpserver</tt> is running.
	<li><tt>-X</tt>:
	With <tt>-x <i>cdb</i></tt>,
	allow connections even if <tt><i>cdb</i></tt> does not exist.
	Normally
	<tt>tcpserver</tt> will drop the connection
	if <tt><i>cdb</i></tt> does not exist.
	<li><tt>-B <i>banner</i></tt>:
	Write <tt><i>banner</i></tt> to the network
	immediately after each connection is made.
	<tt>tcpserver</tt> writes <tt><i>banner</i></tt>
	before looking up <tt>$TCPREMOTEHOST</tt>,
	before looking up <tt>$TCPREMOTEINFO</tt>,
	and before checking <tt><i>cdb</i></tt>.
	This feature can be used to reduce latency in protocols
	where the client waits for a greeting from the server.
	<li><tt>-g <i>gid</i></tt>:
	Switch group ID to <tt><i>gid</i></tt> after preparing to receive connections.
	<tt><i>gid</i></tt> must be a positive integer.
	<li><tt>-u <i>uid</i></tt>:
	Switch user ID to <tt><i>uid</i></tt> after preparing to receive connections.
	<tt><i>uid</i></tt> must be a positive integer.
	<li><tt>-U</tt>: Same as <tt>-g $GID -u $UID</tt>.
	Typically <tt>$GID</tt> and <tt>$UID</tt> are set by
	<a href="../daemontools/envuidgid.html"><tt>envuidgid</tt></a>.
	<li><tt>-1</tt>:
	After preparing to receive connections,
	print the local port number to standard output.
	<li><tt>-b <i>n</i></tt>:
	Allow a backlog of approximately <tt><i>n</i></tt> TCP SYNs.
	On some systems, <tt><i>n</i></tt> is silently limited to 5.
	On systems supporting SYN cookies, the backlog is irrelevant.
	<li><tt>-o</tt>: Leave IP options alone.
	If the client is sending packets along an IP source route,
	send packets back along the same route.
	<li><tt>-O</tt>: (Default.) Kill IP options.
	A client can still use source routing
	to connect and to send data,
	but packets will be sent back along the default route.
	<li><tt>-d</tt>: Delay sending data for a fraction of a second
	whenever the remote host is responding slowly.
	This is currently the default, but it may not be in the future;
	if you want it, set it explicitly.
	<li><tt>-D</tt>: Never delay sending data; enable <tt>TCP_NODELAY</tt>.
	</ul>
	Data-gathering options:
	<ul>
	<li><tt>-h</tt>: (Default.)
	Look up the remote host name in DNS
	to set the environment variable <tt>$TCPREMOTEHOST</tt>.
	<li><tt>-H</tt>:
	Do not look up the remote host name in DNS;
	remove the environment variable <tt>$TCPREMOTEHOST</tt>.
	To avoid loops,
	you <i>must</i> use this option for servers on TCP port 53.
	<li><tt>-p</tt>: Paranoid.
	After looking up the remote host name in DNS,
	look up the IP addresses in DNS for that host name,
	and remove the environment variable <tt>$TCPREMOTEHOST</tt>
	if none of the addresses match the client's IP address.
	<li><tt>-P</tt>: (Default.) Not paranoid.
	<li><tt>-l <i>localname</i></tt>:
	Do not look up the local host name in DNS;
	use <tt><i>localname</i></tt> for the environment variable <tt>$TCPLOCALHOST</tt>.
	A common choice for <tt><i>localname</i></tt> is <tt>0</tt>.
	To avoid loops,
	you <i>must</i> use this option for servers on TCP port 53.
	<li><tt>-r</tt>: (Default.)
	Attempt to obtain <tt>$TCPREMOTEINFO</tt> from the remote host.
	<li><tt>-R</tt>:
	Do not attempt to obtain <tt>$TCPREMOTEINFO</tt> from the remote host.
	To avoid loops,
	you <i>must</i> use this option for servers on TCP ports 53 and 113.
	<li><tt>-t <i>n</i></tt>:
	Give up on the <tt>$TCPREMOTEINFO</tt> connection attempt
	after <tt><i>n</i></tt> seconds.
	Default: 26.
	</ul>
	</body>
	</html>
.
f 'doc/ucspi-tcp/upgrade.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>Upgrading from previous versions of ucspi-tcp</h1>
	<h2>0.84 to 0.86 or 0.87</h2>
	There are sweeping internal changes in 0.86;
	almost all of the code has been rewritten.
	<p>
	<tt>tcpclient</tt>, <tt>tcpserver</tt>, and <tt>rblsmtpd</tt>
	now use the DNS library from 
	<a href="../djbdns.html">djbdns</a>
	to perform DNS lookups.
	This improves reliability, reduces memory consumption, and adds new
	<a href="../djbdns/qualify.html">name-qualification features</a>.
	It's conceivable, however,
	that someone is relying on some other client feature
	provided by the system's <tt>res</tt> routines
	but not by my library.
	If you notice any differences in DNS behavior, please let me know.
	<p>
	The <tt>tcprulescheck</tt> interface has changed.
	It now uses environment variables instead of command-line arguments.
	<p>
	The <tt>-R</tt> option to <tt>rblsmtpd</tt> is now called <tt>-c</tt>.
	If you're using <tt>-b</tt> or <tt>-c</tt>,
	make sure that they appear <i>before</i> <tt>-r</tt>.
	<p>
	The old <tt>antirbl</tt> program is gone.
	You should convert an <tt>rblsmtpd</tt>+<tt>antirbl</tt> chain
	to a single <tt>rblsmtpd</tt>
	with a series of <tt>-r</tt> and <tt>-a</tt> options.
	<p>
	The old <tt>fixcr</tt> program is gone.
	There's a new, easier-to-use <tt>fixcrio</tt> program.
	<p>
	All the programs now use my <tt>pathexec</tt> library to run other programs,
	instead of <tt>execvp</tt>.
	If you've written a shell script without <tt>#!/bin/sh</tt>,
	and you're relying on <tt>execvp</tt> to invoke <tt>/bin/sh</tt> anyway,
	you'll have to insert <tt>#!/bin/sh</tt> at the top of the script
	to make it work with <tt>pathexec</tt> (or <tt>execve</tt>).
	<p>
	<tt>http@</tt> now does a slightly better imitation of a browser:
	it sends <tt>Host</tt> to the HTTP server.
	In some cases this changes the response.
	<p>
	Future versions of <tt>tcpclient</tt> and <tt>tcpserver</tt>
	may use <tt>-D</tt> by default.
	If you want <tt>-d</tt> for some reason, set it explicitly.
	<p>
	<tt>tcpserver</tt> has a new <tt>-U</tt> option
	that reads environment variables set by
	<a href="../daemontools/envuidgid.html">envuidgid</a>.
	You will probably want to use this in place of <tt>-u</tt> and <tt>-g</tt>
	so that you don't have to copy numeric uids and gids.
	<h2>0.86 or 0.87 to 0.88</h2>
	<tt>tcpclient</tt> uses a new strategy for connecting to multiple IP addresses:
	it tries each address with a 2-second timeout,
	then retries the addresses that timed out with a 58-second timeout.
	This drastically reduces latency when some of the addresses are unresponsive.
	(A system-supported connect-to-multiple-addresses feature
	would be even better.)
	It's conceivable, however,
	that someone is relying on the old behavior.
	</body>
	</html>
.
f 'doc/ucspi-tcp/who@.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="../djb.html">D. J. Bernstein</a>
	<br><a href="../tcpip.html">TCP/IP</a>
	<br><a href="../ucspi-tcp.html">ucspi-tcp</a>
	<h1>The <tt>who@</tt> program</h1>
	<tt>who@</tt> prints the list of active users on a remote host.
	<h2>Interface</h2>
	<pre>
	     who@ <i>host</i>
	</pre>
	<tt>who@</tt> connects to TCP port 11 (Systat)
	on <tt><i>host</i></tt>
	and prints any data it receives.
	It removes CR (\015) and converts unprintable characters
	to a visible format.
	<p>
	If <tt><i>host</i></tt> is not supplied,
	<tt>who@</tt> connects to the local host.
	<p>
	Some computers respond to port 11
	with a list of active users.
	For example, they may be running
	<pre>
	     tcpserver -RHl0 0 11 who
	</pre>
	using <a href="tcpserver.html"><tt>tcpserver</tt></a>.
	</body>
	</html>
.
f 'doc/ucspi-tcp.html' 644 0:0 <<'.'
	<html>
	<body>
	<a href="djb.html">D. J. Bernstein</a>
	<br><a href="tcpip.html">TCP/IP</a>
	<h1>ucspi-tcp</h1>
	<a href="ucspi-tcp/install.html">How to install ucspi-tcp</a>
	<br><a href="ucspi-tcp/upgrade.html">Upgrading from previous versions of ucspi-tcp</a>
	<p>
	<a href="ucspi-tcp/tcpserver.html">The <tt>tcpserver</tt> program</a>
	<br><a href="ucspi-tcp/tcprules.html">The <tt>tcprules</tt> program</a>
	<br><a href="ucspi-tcp/tcprulescheck.html">The <tt>tcprulescheck</tt> program</a>
	<br><a href="ucspi-tcp/argv0.html">The <tt>argv0</tt> program</a>
	<br><a href="ucspi-tcp/fixcrio.html">The <tt>fixcrio</tt> program</a>
	<br><a href="ucspi-tcp/recordio.html">The <tt>recordio</tt> program</a>
	<br><a href="ucspi-tcp/rblsmtpd.html">The <tt>rblsmtpd</tt> program</a>
	<p>
	<a href="ucspi-tcp/tcpclient.html">The <tt>tcpclient</tt> program</a>
	<br><a href="ucspi-tcp/who@.html">The <tt>who@</tt> program</a>
	<br><a href="ucspi-tcp/date@.html">The <tt>date@</tt> program</a>
	<br><a href="ucspi-tcp/finger@.html">The <tt>finger@</tt> program</a>
	<br><a href="ucspi-tcp/http@.html">The <tt>http@</tt> program</a>
	<br><a href="ucspi-tcp/tcpcat.html">The <tt>tcpcat</tt> program</a>
	<br><a href="ucspi-tcp/mconnect.html">The <tt>mconnect</tt> program</a>
	<br><a href="ucspi-tcp/addcr.html">The <tt>addcr</tt> and <tt>delcr</tt> programs</a>
	<p>
	<a href="ucspi-tcp/environment.html">TCP environment variables</a>
	<hr>
	<h2>What is it?</h2>
	tcpserver and tcpclient are easy-to-use command-line tools for building
	TCP client-server applications.
	<p>
	<b>tcpserver</b> waits for incoming connections and, for each connection, runs
	a program of your choice. Your program receives environment variables
	showing the local and remote host names, IP addresses, and port numbers.
	<p>
	tcpserver offers a concurrency limit to protect you from running out of
	processes and memory. When you are handling 40 (by default) simultaneous
	connections, tcpserver smoothly defers acceptance of new connections.
	<p>
	tcpserver also provides TCP access control features, similar to
	tcp-wrappers/tcpd's hosts.allow but much faster. Its access control
	rules are compiled into a hashed format with
	<a href="cdb.html">cdb</a>,
	so it can easily deal
	with thousands of different hosts.
	<p>
	This package includes a recordio tool that monitors all the input and
	output of a server.
	<p>
	<b>tcpclient</b> makes a TCP connection and runs a program of your choice. It
	sets up the same environment variables as tcpserver.
	<p>
	This package includes several sample clients built on top of tcpclient:
	who@, date@, finger@, http@, tcpcat, and mconnect.
	<p>
	tcpserver and tcpclient conform to
	<a href="proto/ucspi.txt">UCSPI</a>,
	the UNIX Client-Server Program Interface,
	using the
	<a href="proto/ucspi-tcp.txt">TCP</a>
	protocol. UCSPI tools are available for several different networks.
	<h2>Other command-line TCP tools</h2>
	The current ucspi-tcp interface is a refinement of the
	tcpserver/tcpclient interface in my 1991 clientserver package,
	which replaced the attachport/authtcp interface in my 1989 auth package.
	<p>
	ucspi-tcp now competes with several other programs:
	<ul>
	<li>inetd, a root-only TCP server supplied by all UNIX vendors;
	<li>xinetd, a replacement for inetd;
	<li>the mconnect client supplied as part of SunOS;
	<li>the
	<a href="http://www.jnickelsen.de/socket/">socket</a>
	program;
	<li>faucet and hose,
	part of the
	<a href="http://web.purplefrog.com/~thoth/netpipes/">netpipes</a>
	package; and
	<li>the
	<a href="http://www.avian.org/web1/hak/netcat.html">netcat</a>
	program, which also supports UDP.
	</ul>
	<p>
	Many sites are replacing inetd with tcpserver, for several reasons:
	<ul>
	<li>inetd is unreliable under high loads.
	It cuts off service for 10 minutes
	if it receives ``too many'' connections in 1 minute.
	<li>inetd does not provide effective resource management.
	It will happily
	<a href="docs/inetd.html">use up all your memory</a>
	if you are running a popular service.
	<li>inetd has trouble with sudden bursts of activity.
	Its listen() backlog is typically only 5 or 10 and cannot be raised.
	</ul>
	</body>
	</html>
.
